angular.module('myApp')

.controller("EntropyCtrl", function($rootScope, $scope, $firebaseArray, pointsMgmt, taskMgmt) {

  $scope.result = "";
  $scope.done = 0;

  $scope.testInput = function() {
    var lowercase = false;
    var uppercase = false;
    var symbol		= false;

    var str = $scope.pwinput;
    
    if (/[a-z]/.test(str)) { lowercase = true; }
    
    if (/[A-Z]/.test(str)) { uppercase = true; }
    
    if (/\W/g.test(str)) { symbol = true; }

    if (lowercase && uppercase && symbol) {
      $scope.result = time(entropy(str.length) + 6);
    } else {
      $scope.result = time(entropy(str.length));
    }
  
    $scope.done++;

    if ($scope.done == 10) {
      pointsMgmt.addPoints(100);
    }
  }

  function time(bits) {
    var seconds = Math.pow(2, bits) / 1000;

    if (seconds >= 31540000) {
      return Math.floor(seconds / 31540000) + " years";
    } else if (seconds >= 86400) {
      return Math.floor(seconds / 86400) + " days";
    } else if (seconds >= 3600) {
      return Math.floor(seconds / 3600) + " hours";
    } else if (seconds >= 60) {
      return Math.floor(seconds / 60) + " minutes";
    } else {
      return Math.floor(seconds) + " seconds";
    }

  }

  function entropy(length) {	
    if (length > 12) {
    	return 36 + (length - 20);
    } else if (length > 8) {
    	return 18 + (length - 8) * 1.5;
    } else {
    	return 4 + (length - 1) * 2;
    }
  }

})