angular.module('myApp')

.controller('LessonCtrl', function($rootScope, $scope, $firebaseArray, dbref, taskMgmt, pointsMgmt) {

	$scope.clicked = false;
	$scope.done = false;
	$scope.items = [];
	$scope.checked = [];

	var count = 0;

	$scope.startLesson = function() {
		// Get task meta from rootscope.
		var category = $rootScope.category;
		var taskId = $rootScope.taskId;

		// Lesson posts ref.
		var ref = new Firebase(dbref)
			.child('tasks')
			.child(category)
			.child(taskId)
			.child('posts');

		var posts = $firebaseArray(ref);

		posts.$loaded().then(function() {
			// Send posts to scope.
			$scope.items = posts;

			// Get post count.
			var pcount = posts.length;

			// Set UI Bootstrap pager parameters.
			$scope.currentPage = 1;
			$scope.totalItems = pcount * 10;
			$scope.numPages = pcount;
			$scope.clicked = true;

		}).catch(function(err) {
			console.log(err);
		});	
	}

	$scope.gotit = function() {
		count++;
		if (count == $scope.numPages) {
			$scope.done = true;
			var points = $rootScope.task['points'];
			pointsMgmt.addPoints(points);
		}
	}

  $scope.$watch('currentPage', function() {
    $scope.cut = $scope.items.slice($scope.currentPage -1, $scope.currentPage);
  });
});