angular.module('myApp').controller('NtCtrl', function($scope, $firebaseArray, dbref) {

  $scope.submitTask = function() {
    $scope.task['count'] = 0;
    
    switch($scope.task['type']) {

      case 'Article':
        submitArticle();
        break;

      case 'Quiz':
        submitQuiz();
        break;

      case 'Lesson':
        submitLesson();
        break;
    }

    var ref = new Firebase(dbref)
      .child('tasks')
      .child('counts')
      .child($scope.category);

    ref.once('value', function(data) {
      ref.set(data.val() + 1);
    });

  }

  /* 
  ** QUIZ 
  */

  $scope.questions = [];

  $scope.addQuizQuestion = function() {
    $scope.questions.push({
      question : "",
      answers  : "",
      solution : "",
    });
  }

  function submitQuiz() {
    // Task reference.
    var tref = new Firebase(dbref)
      .child('tasks')
      .child($scope.category);

    // Solution reference.
    var sref = new Firebase(dbref)
      .child('solutions');
    
    // Push task to firebase.
    var tkey = tref.push($scope.task);

    // Iterate through all questions.
    $scope.questions.forEach(function(question) {
      // Push question to task.
      var qkey = tref.child(tkey.key())
        .child('questions')
        .push({'question': question['question']});

      // Submit answers alternatives.
      var answers = question['answers'].split('\n');
      tref.child(tkey.key())
        .child('questions')
        .child(qkey.key())
        .child('answers')
        .set(answers);

      // Submit solution.
      var solution = question['solution'];
      sref.child(tkey.key())
        .child(qkey.key())
        .set(solution);
    });
  }


  /*
  ** ARTICLE
  */


  function submitArticle() {
    var ref = new Firebase(dbref);
    
    // Push task to firebase.
    var key = ref.child('tasks')
      .child($scope.category)
      .push($scope.task);

    // Submit answer alternatives to control question.
    var answers = $scope.control['answers'].split('\n');
    answers.forEach(function(answer) {
      ref.child('tasks')
        .child($scope.category)
        .child(key.key())
        .child('answers')
        .push(answer);
    });

    // Submit solution.
    ref.child('solutions')
      .child(key.key())
      .push($scope.control['solution']);
  }

  /*
  ** LESSON
  */

  $scope.posts = [];

  $scope.addLessonPost = function() {
    $scope.posts.push({
      topic : "",
      text  : ""
    });
  }

  function submitLesson() {
    // Category reference.
    var ref = new Firebase(dbref)
      .child('tasks')
      .child($scope.category);
    
    // Push task to firebase.
    var task = ref.push($scope.task);

    // Iterate through all posts.
    $scope.posts.forEach(function(post) {
      // Push post to task.
      task.child('posts').push({
        topic: post['topic'], 
        text: post['text']
      });
    });
  }
  





  function genId(ids) {
  	var id = -1;

  	while (id == -1) {
  		var rnd = Math.floor(Math.random() * 4);
  		if (!isInArray(rnd, ids)) {
  			id = rnd;
  		}
  	}
  	return id;
  }

  function isInArray(value, array) {
  	return array.indexOf(value) > -1;
	}	

  function submitSolutions(taskId, solutions) {
		var sRef = $firebaseArray(new Firebase("https://sizzling-torch-4195.firebaseio.com/solutions/" + taskId));

		solutions.forEach(function(solution) {
			sRef.$add(solution)
				.then(function() {
				  console.log("Added solution to [" + taskId + "]");
				})
				.catch(function(err) {
					console.log(err);
				});
		});

  }


});