angular.module('myApp')

.controller('QuizCtrl', function($rootScope, $scope, $firebaseArray, dbref, Auth, taskMgmt, pointsMgmt) {

	$scope.items = [];
	$scope.answers = {};
	$scope.selections = [];

	$scope.clicked = false;

	$scope.startQuiz = function() {
		// Get task meta from rootscope.
		var category = $rootScope.category;
		var taskId = $rootScope.taskId;

		// Firebase questions ref.
		var ref = new Firebase(dbref)
			.child('tasks')
			.child(category)
			.child(taskId)
			.child('questions');

		var questions = $firebaseArray(ref);

		questions.$loaded().then(function() {
			// Send questions to scope.
			$scope.items = questions;
			
			// Get question count.
			var count = questions.length;
			
			// Set UI Bootstrap pagination parameters.
			$scope.currentPage = 1;
			$scope.totalItems = count * 10;
			$scope.numPages = count;

			// Show quiz.
			$scope.clicked = true;
		});
	}

	$scope.recordAnswer = function(page, answer, qid) {
		$scope.answers[qid] = {
			page 		: page,
			answer 	: answer
		};
	}

	$scope.checkAnswers = function() {
		var taskId = $rootScope.taskId;
		var points = $rootScope.task['points'];

		$scope.correct = true;
		var wrong = [];

		var ref = new Firebase(dbref)
			.child('solutions')
			.child(taskId);

		var solutions = $firebaseArray(ref);

		solutions.$loaded().then(function() {
			solutions.forEach(function(solution) {
				var id = solution['$id'];
				var answer = solution['$value'];

				try {
					if ($scope.answers[id]['answer'] != answer) {
						wrong.push($scope.answers[id]['page']);
						$scope.correct = false;
					} 
				} 
				catch(err) {
					$scope.incorrect = "You have not answered all the questions."
					$scope.correct = false;
				};

			});

			if ($scope.correct) {
				pointsMgmt.addPoints(points);
			}

			else {
				if (wrong.length > 1) {
	   			$scope.incorrect = "The answers to questions " + wrong + " are incorrect.";
	   		} else if (wrong.length == 1) {
	   			$scope.incorrect = "The answer to question " + wrong + " is incorrect."; 
	   		}
			}

		});
	}

	$scope.reset = function() {
		$scope.incorrect = "";
	}

/*
	$scope.sendAnswers = function() {

		$scope.answers['uid'] = authData.uid;
		$scope.answers['tid'] = taskMgmt.getCurrent()[2];

		$http.post('/quiz', $scope.answers)
			.then(function(res) {
				console.log(res.data);
			})
			.catch(function(err) {
				console.log(err);
			});
	}
  */
  $scope.$watch('currentPage', function() {
    $scope.cut = $scope.items.slice($scope.currentPage -1, $scope.currentPage);
  });
});