angular.module('myApp')

.controller('SidebarCtrl', function($rootScope, $scope, $firebaseObject, $firebaseArray, $location, Auth, dbref, timelineMgmt) {

    var uid = Auth.$getAuth().uid;

    var user = $firebaseObject(new Firebase(dbref).child('users').child(uid));
    user.$bindTo($rootScope, 'user');

    $scope.mpoints = function(points) {
      var mpoints = 0;
      
      if (points < 500) {
        mpoints = 500 - points;
      } else if (points >= 500) {
        mpoints = 1000 - points;
      }
      
      return mpoints;
    }


      var ref = new Firebase(dbref).child('users');
      var query = ref.orderByChild('points');

      var list = $firebaseArray(query);

      list.$loaded().then(function() {
        $scope.ranking = list;
      })

    $scope.logout = function() {
      Auth.$unauth();
      $location.path("/login");
    }

    $scope.addEvent = function(alias) {
      //timelineMgmt.addEventStart(alias);
      var c = new Firebase(dbref + "/users/" + uid + "/alias")
      c.on('value', function(data) {
        hei = data.val();
      });
      console.log(hei)
    }

    $scope.events = $firebaseArray(new Firebase(dbref + "/timeline/"));
    
    $scope.disable = true;

    $scope.timeSince = function(date) {
      var seconds = Math.floor((new Date() - date) / 1000);

      var interval = Math.floor(seconds / 31536000);

      if (interval > 1) {
          return interval + " years";
      }
      interval = Math.floor(seconds / 2592000);
      if (interval > 1) {
          return interval + " months";
      }
      interval = Math.floor(seconds / 86400);
      if (interval >= 1) {
          return interval + " days";
      }
      interval = Math.floor(seconds / 3600);
      if (interval >= 1) {
          return interval + " hours";
      }
      interval = Math.floor(seconds / 60);
      if (interval >= 1) {
          return interval + " minutes";
      }
      return Math.floor(seconds) + " seconds";
    }

})

.filter('myfilter', function() {
  return function(items, user, disable) {
    if (disable) return items;

    var filtered = [];

    angular.forEach(items, function(item) {
      if (item['user'] == user) {
        filtered.push(item);
      }
    });

    return filtered;
  }
})

.filter('lb', function() {
  return function(items, user) {
    var ranking = null;
    angular.forEach(items, function(item) {
      if (item['alias'] == user) ranking = items.length - items.indexOf(item);
    });
    return ranking;
  }
})